package cz.frantovo.hrisniciSpameri.dao;

import cz.frantovo.superDAO.SuperDAO;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.logging.Level;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 *
 * @author fiki
 */
public class HrisniciSuperDAO extends SuperDAO {

    protected InitialContext kontext = null;

    protected enum DATABAZE {

        HRISNICI
    }

    public HrisniciSuperDAO() {
        try {
            kontext = new InitialContext();
        } catch (NamingException ex) {
            log.log(Level.SEVERE, "Chyba při inicializaci kontextu", ex);
        }
    }

    /**
     * <ul>
     *  <li>Webová část zadává jako parametr null →
     *  dostane výchozí spojení do PostgreSQL databáze obsahující vygenerované souhrny.</li>
     *  <li>Generovací servlet zadává JNDI jméno databáze cíle →
     *  dostane zdrojovou databázi, ze které vygeneruje denní souhrny a výsledek uloží do výchozí databáze.</li>
     * </ul>
     * @param jndi JNDI jméno, pokud je null, vrací výchozí spojení.
     * @return Databázové spojení
     */
    protected Connection getSpojeni(String jndi) {
        if (jndi == null || jndi.length() < 1) {
            jndi = getVlastnost(DATABAZE.HRISNICI, HrisniciSuperDAO.class);
        }
        jndi = orizniJNDI(jndi);
        DataSource zdroj = null;
        try {
            zdroj = (DataSource) kontext.lookup(jndi);
            return zdroj.getConnection();
        } catch (NamingException ex) {
            log.log(Level.SEVERE, "getSpojeni: lookup", ex);
            return null;
        } catch (SQLException ex) {
            log.log(Level.SEVERE, "getSpojeni: sql", ex);
            return null;
        }
    }
}
